class Referencia
	include Comparable
	attr_reader :autores, :titulo, :serie, :editorial, :nedicion, :fecha, :isbn10, :isbn13
	def initialize(aut,tit,ser,edi,ne,fe,is10,is13)

		if aut.any?
			@autores=aut
		else
			raise ArgumentError.new("Error: Se requiere al menos un autor")
		end
		if !tit.nil?
			@titulo=tit
		else
			raise ArgumentError.new("Error: Se requiere un tiulo")
		end
		@serie=ser
		if !edi.nil?
			@editorial=edi
		else
			raise ArgumentError.new("Error: Se requiere una editorial")
		end
		if !ne.nil?
			@nedicion=ne
		else
			raise ArgumentError.new("Error Se requiere un numero de edicion")
		end
		if !fe.nil?
			@fecha=Date::strptime(fe, "%d-%m-%Y")
		else
			raise ArgumentError.new("Error: Se requiere una fecha con formato %d-%m-%Y")
		end
		if !is10.nil? || !is13.nil?
			@isbn10=is10
			@isbn13=is13
		else
			raise ArgumentError.new("Error: Se requiere al menos un codigo isbn")
		end
	end

	def self.crear &block
		newref = Referencia.new([""],"","","",0,"01-01-1990",[],[])
		newref.evaluar(&block)
		return newref
	end

	def evaluar &block
		@autores = []
		instance_eval &block
	end

	def <=>(referencia)
		if(@autores[0] <=> referencia.autores[0])
			if(@autores.count<=>referencia.autores.count)
				if(@fecha <=> referencia.fecha)
					@titulo <=> referencia.titulo
				end
			end
		end
	end

	def to_s
		splitnames = []
		@autores.each do |nombre|
			listanombres = nombre.split
			nombre = listanombres[0]
			apellidos = listanombres[1..-1].join(" ").capitalize
			splitnames.push(apellidos + ", " + nombre[0])
		end
		"Autor: #{splitnames.join(" & ")} (#{@fecha}). Titulo del libro: #{@titulo.capitalize} (#{@nedicion}). Lugar de publicacion: #{@editorial}"
	end

	def AUTOR nombre
		@autores << nombre
	end

	def TITULO nombre
		@titulo = nombre
	end

	def SERIE serie
		@serie = serie	
	end

	def EDITORIAL edit
		@editorial = edit
	end

	def EDICION edicion
		@nedicion = edicion
	end

	def FECHA fecha
		@fecha = fecha
	end

	def ISBN10 isbn
		@isbn10 << isbn
	end

	def ISBN13 isbn
		@isbn13 << isbn
	end
end
